#include "includes.h"
extern Jogo *jogo;

//// Construtores
//
HighScores::HighScores(){
	this->initScores();
}

HighScores::~HighScores(){}

//// Mtodos Publicos
//

bool HighScores::updateScores(char *nomeJogador, unsigned long int pontuacao){
	SCORE *listaHighScores;
	SCORE listaTmp[MAX_NUM_SCORES];
	SCORE newScore;
	int i,j;
	bool pontuacaoNosHighScores = false;

	// destingue em que tabela vai fazer update
	if(jogo->getNivelDificuldade() == NORMAL)
		listaHighScores = this->listaHighScoresNormal;
	else
		listaHighScores = this->listaHighScoresHard;
	//---

	// listaTmp
	for(i=0; i<MAX_NUM_SCORES; i++)
		this->copyScore(&listaTmp[i], &listaHighScores[i]);
	//---

	// actualiza
	for(i=0; i<MAX_NUM_SCORES; i++){
		if(listaHighScores[i].pontuacao < pontuacao){
			pontuacaoNosHighScores = true;
			// Actualiza HighScore Neste Ponto
			strcpy(newScore.nomeJogador, nomeJogador);
			newScore.pontuacao = pontuacao;
			this->copyScore(&listaHighScores[i], &newScore);
			
			for(j=i++; i<MAX_NUM_SCORES; i++, j++)
				this->copyScore(&listaHighScores[i], &listaTmp[j]);
		}
	}

	if(pontuacaoNosHighScores)
		this->saveScoresDisco(); // guarda o ficheiro
	return pontuacaoNosHighScores;
}

//// Mtodos Privados
//

void HighScores::initScores(){
	int i;
	
	for(i=0; i<MAX_NUM_SCORES; i++){
		this->listaHighScoresNormal[i].nomeJogador[0] = '\0';
		this->listaHighScoresNormal[i].pontuacao = 0;
		this->listaHighScoresHard[i].nomeJogador[0] = '\0';
		this->listaHighScoresHard[i].pontuacao = 0;
	}

	this->loadScoresGuardados();
}

void HighScores::loadScoresGuardados(){
	FILE *fp;
	
	if((fp = fopen(SCORES_FILE_NAME, "rb")) == NULL)
		return;

	fread(this->listaHighScoresNormal, sizeof(SCORE), MAX_NUM_SCORES, fp);
	fread(this->listaHighScoresHard, sizeof(SCORE), MAX_NUM_SCORES, fp);

	fclose(fp);
}

void HighScores::saveScoresDisco(){
	FILE *fp;

	if((fp = fopen(SCORES_FILE_NAME, "wb")) == NULL)
		return;
	
	fwrite(this->listaHighScoresNormal, sizeof(SCORE), MAX_NUM_SCORES, fp);
	fwrite(this->listaHighScoresHard, sizeof(SCORE), MAX_NUM_SCORES, fp);

	fclose(fp);
}

SCORE *HighScores::copyScore(SCORE *destino, SCORE *origem){
	if(destino == NULL)
		destino = new SCORE;
	strcpy(destino->nomeJogador, origem->nomeJogador);
	destino->pontuacao = origem->pontuacao;

	return destino;
}

//// Getters and Setters
//

SCORE *HighScores::daListaHighScoresNormal(){
	return this->listaHighScoresNormal;
}

SCORE *HighScores::daListaHighScoresHard(){
	return this->listaHighScoresHard;
}